;
;       Duck shoot from the MK14 Manual
;
;       Shoot ducks by hitting number corresponding to their position
;       7 = left, 0 = right, if you miss another duck appears.
;

#define DatPtr(x)       ((x)+1)         ; useful SC/MP macros
#define High(x)         ((x)/256)
#define Low(x)          ((x) & 255)

Duck    .equ    061h
Disp    .equ    0D00h
Row     .equ    DatPtr(0F0Fh)           ; bits set = ducks
Count   .equ    DatPtr(0F10h)
Sum     .equ    DatPtr(0F11h)           ; key pressed

        .org    0F12h

Shoot:  ldi     High(Disp)
        xpah    1
        ldi     Low(Disp)
        xpal    1
        ldi     1                       ; start with 1 duck
        st      Row
React:  ldi     16                      ; speed of flight
        st      Count                   ; smaller = harder
        ldi     0
        st      Sum
Shift:  ldi     8                       ; move ducks this time
NDig:   xae
        ld      Row
        rr
        st      Row
        jp      No
        ldi     Duck                    ; duck to display
        jmp     Go
No:     ldi     0                       ; no duck
Go:     st      80h(1)                  ; light the digit
        dly     01h
        ld      Sum
        jnz     Nok                     ; key already pressed ?
        ld      80h(1)                  ; test for key
        xri     0FFh
        jz      Nok                     ; no key
        st      Sum
        ld      Row                     ; change top bit to kill or create
        xri     80h
        st      Row
Nok:    lde                             ; next digit
        scl
        cai     1
        jp      NDig
        dld     Count
        jz      React                   ; start new position
        ldi     7
        jmp     NDig                    ; another sweep
        .end

